import { IOptions } from './IOptions';
import { GlobMatcher, GlobPatternWithRoot } from 'cspell-glob';
import { CSpellUserSettings, Glob } from '@cspell/cspell-types';
export interface GlobOptions extends IOptions {
    cwd?: string;
    root?: string;
    ignore?: string | string[];
}
/**
 *
 * @param pattern - glob patterns and NOT file paths. It can be a file path turned into a glob.
 * @param options - search options.
 */
export declare function globP(pattern: string | string[], options?: GlobOptions): Promise<string[]>;
export declare function calcGlobs(commandLineExclude: string[] | undefined): {
    globs: string[];
    source: string;
};
export interface GlobSrcInfo {
    matcher: GlobMatcher;
    source: string;
}
interface ExtractPatternResult {
    glob: GlobPatternWithRoot;
    source: string;
}
export declare function extractPatterns(globs: GlobSrcInfo[]): ExtractPatternResult[];
export declare function calcExcludeGlobInfo(root: string, commandLineExclude: string[] | string | undefined): GlobSrcInfo[];
export declare function extractGlobExcludesFromConfig(root: string, source: string, config: CSpellUserSettings): GlobSrcInfo[];
/**
 *
 * @param globs Glob patterns.
 * @param root
 */
export declare function normalizeGlobsToRoot(globs: Glob[], root: string, isExclude: boolean): string[];
export {};
